Last Comment Bug 103189 - ::first-letter pseudo elements show no border property
: ::first-letter pseudo elements show no border property
Status: RESOLVED WORKSFORME
[CSS1-2.4] (new bugs filled?)
: css1, regression, testcase
Product: Core
Classification: Components
Component: CSS Parsing and Computation (show other bugs)
: Trunk
: All All
: P2 normal with 3 votes (vote)
: mozilla1.2beta
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
: 188654 (view as bug list)
Depends on:
Blocks: 153699 83479 191272
  Show dependency treegraph
 
Reported: 2001-10-04 12:52 PDT by Dylan Schiemann
Modified: 2014-04-26 03:11 PDT (History)
10 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
testcase: set first-letter pseudo element to have a 3px black border (568 bytes, text/html)
2001-10-04 12:53 PDT, Dylan Schiemann
no flags Details
bring the :first-letter/:first-line rules in nsHTMLCSSStyleSheet mostly up to spec (13.13 KB, patch)
2002-05-06 12:55 PDT, David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch)
no flags Details | Diff | Review
slightly better patch; still some problems (13.14 KB, patch)
2002-05-19 19:36 PDT, David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch)
no flags Details | Diff | Review
patch (12.81 KB, patch)
2003-01-30 16:49 PST, David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch)
bzbarsky: review+
bzbarsky: superreview+
Details | Diff | Review
Testcase - margin:inherit (940 bytes, text/html)
2004-11-22 17:41 PST, Mats Palmgren (:mats)
no flags Details

Description Dylan Schiemann 2001-10-04 12:52:37 PDT
Steps to reproduce:
1) Set border properties on first-letter pseudo element

Expected Bahvior:
1) Border around first-letter

Actual Behavior:
1) No Border is visible
This may be a regression.  Builds as recent as 0.9.2 would show a border for
first-letter pseudo elements, but 0.9.4 does not.  Testcase to follow
Comment 1 Dylan Schiemann 2001-10-04 12:53:56 PDT
Created attachment 52082 [details]
testcase: set first-letter pseudo element to have a 3px black border
Comment 2 basic 2001-10-04 16:13:07 PDT
guess this is a regression.
Comment 3 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2001-10-04 23:35:47 PDT
This sounds like it's more likely to be a layout problem than style system.
Comment 4 Marc Attinasi 2001-10-09 15:52:09 PDT
99% sure this regressed with the rule tree landing. It worked in the 05-31
build, but not in the 06-01 build. Reassign to hyatt and putting [RULETREE] in
summary
Comment 5 David Hyatt 2001-10-09 18:53:29 PDT
Oh boy oh boy oh boy!
Comment 6 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2001-11-09 02:04:26 PST
Oh, there's code to do this intentionally in nsHTMLCSSStyleSheet.  It just has
to be removed in the right way.
Comment 7 Peter Trudelle 2002-02-21 11:54:44 PST
What effect will this have on users of MachV?
Comment 8 Daniel Glazman (:glazou) 2002-05-06 03:18:22 PDT
Adding a "Dropped Initial" feature to Composer, I just discovered this bug too.
We don't draw borders on :first-letter.

IE and Opera don't have this bug. Konqueror has same bug.
Comment 9 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2002-05-06 12:55:50 PDT
Created attachment 82512 [details] [diff] [review]
bring the :first-letter/:first-line rules in nsHTMLCSSStyleSheet mostly up to spec

This is a preliminary patch.
Comment 10 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2002-05-06 12:58:29 PDT
It might be a better solution if we did this work in nsRuleNode.cpp like we do
for :before and :after, though...
Comment 11 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2002-05-19 19:36:14 PDT
Created attachment 84214 [details] [diff] [review]
slightly better patch; still some problems

This one at least compiles and runs without assertions.
Comment 12 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2002-06-06 21:02:50 PDT
Taking the bug.  This really needs to be a post-resolve callback, though.
Comment 13 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2002-06-06 21:04:52 PDT
And while I think of it, this should be fixed for XML documents too...
Comment 14 Greg K. 2002-06-23 15:57:14 PDT
Also observed using FizzillaCFM/2002061014. Marking All/All.
Comment 15 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2003-01-11 07:48:35 PST
*** Bug 188654 has been marked as a duplicate of this bug. ***
Comment 16 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2003-01-30 16:48:07 PST
Doing it in the post resolve callback or in ApplyStyleFixups will break if
someone does something like 'margin: inherit' and gets the struct from the
parent, unless we go through a lot of work.  I think I'll just go with what I
have for now.
Comment 17 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2003-01-30 16:49:21 PST
Created attachment 113147 [details] [diff] [review]
patch

Basically just updated.
Comment 18 Boris Zbarsky [:bz] 2003-01-30 18:54:25 PST
Comment on attachment 113147 [details] [diff] [review]
patch

+  // Disable everything in the Display struct except 'float' and
+  // 'clear'.

This should be moved down to just before the code that actually does it, no?

With that, looks good...
Comment 19 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2003-02-22 13:53:13 PST
Fix checked in to trunk, 2003-02-22 11:20 PST.  Still more work to be done here,
so leaving open, at least until I file a separate bug on the various issues
mentioned above.
Comment 20 Anne (:annevk) 2004-09-20 08:28:48 PDT
What about those new bugs?
Comment 21 Mats Palmgren (:mats) 2004-11-22 17:41:57 PST
Created attachment 166811 [details]
Testcase - margin:inherit

David, is this the case you mentioned in comment 16?
Comment 22 Eli Friedman 2007-05-22 01:25:46 PDT
Is there still something left to be done here?
Comment 23 j.j. 2011-09-30 17:01:34 PDT
Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1

The bug as reported is fixed.
Attachment 166811 [details] (comment 21) should be a seperate bug.

Note You need to log in before you can comment on or make changes to this bug.